#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "huffman.h"

int main(int argc, char *argv[])
{
    // Use file name (or stdin) instead of text
    const char *text = (argc > 1) ? argv[1] : "some text that may be well encoded";
    int freq[MAX_UCHAR];
    // Rewrite hist for a stream
    int len = strlen(text);
    hist(len, (const unsigned char *)text, freq);

    struct tree *root = make_huffman_tree(freq);

    struct compressed_stream out = compress_stream(stdout, root);
    write_compressed(&out, len, text);
    close_compressed(&out);

    return 0;
}

